mod Ex05a logic: 'cl'

incl Mtex

incl Mtexg

incl Mauxa

loc rem 
  \para \bf  5. CVICENIE Z PREDMETU 1-AIN-470 SPECIFIKACIA A VERIFIKACIA 
  PROGRAMOV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.19 
  \para* \it  Datum:  \end stvrtok 18.3.2010 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-470-svp/0910ls/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane rekurzii s mierou 
  a chvostovej rekurzii. Zadanie sa sklada z tychto suborov: 
  \items 
   \item \para Subory \it  mtex*.cl  \end obsahuju makra pre CL-TeX. 
   \item \para Subory \it  maux*.cl  \end obsahuju definicie a vlastnosti 
         pomocnych funkcii a predikatov. 
   \item \para Subory \it  ex*.cl  \end obsahuju ulohy, ktore mate riesit na 
         tomto cviceni. 
   \item \para Subor \it  msyntax.cl  \end obsahuje syntax systemu CL. 
   \item \para Subory \it  mlogic*.cl  \end obsahuju popis verifikacneho systemu 
         CL. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  Chapter. Numeric Programs.  \end 

rem 
  \para \bf  Section. Course of Values Recursion.  \end 

rem 
  \para \bf  Subsection. Course of Values Recursion.  \end 

rem 
  \para \bf  Complete mathematical induction.  \end Show that the principle of 
  complete mathematical induction (course of values induction) is admissible in 
  Peano arithmetic. 
  \para \it  Remark.  \end Prove the claim for the special case in the following 
  theory. 
  \para \it  Hint.  \end Reduce complete induction to mathematical induction as 
  described in Sect. 7.3 of [1], pg. 187. 

theory Complete_mathematical_induction

pred A 'Tex2_g_appl_phi_sb'

axiom Progressivity
  \a x(\a y(y < x -> A(y)) -> A(x))

thm Conclusion
  A(x)

end theory Complete_mathematical_induction

rem 
  \para \bf  [CL] Complete mathematical induction.  \end 
  \header* fun R 'Tex2_g_appl_phi_sb' \end Syntax: 
  \eq* 
    'indm <variable> [; <variable(s)>]'
  \end
  \para where the induction formula is formed from the current sequent. 
  \para Example(s): 
  \items 
   \item \para \ft Tex_f1_g_x_indm(x) \end 
         \eq* 
           Tex_f2_g_x_nrule(Tex_f1_g_x_goal R(x),
                            Tex_f1_g_x_goal Tex_f2_g_imp(Tex_f2_g_forall(y,
                                                                         Tex_f2_g_imp(Tex_f2_g_lt(y,
                                                                                                  x),
                                                                                      R(y))),
                                                         R(x)))
         \end
   \item \para \ft Tex_f1_g_x_indm Tex_f2_g_x_sc(x,a) \end 
         \eq* 
           Tex_f2_g_x_nrule(Tex_f1_g_x_goal R(x),
                            Tex_f1_g_x_goal Tex_f2_g_imp(Tex_f2_g_forall(y,
                                                                         Tex_f2_g_imp(Tex_f2_g_lt(y,
                                                                                                  x),
                                                                                      Tex_f2_g_forall(a,
                                                                                                      R(y)))),
                                                         R(x)))
         \end
  \end

rem 
  \para \bf  Integer division.  \end 

fun/2 Div 'Tex_f2_n_div'
  Div(x,0) = 0
  Div(x,y) = 0 <- y != 0 & x < y
  Div(x,y) = Div(x-y,y)+1 <- y != 0 & x >= y

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    y != 0 -> \e r(x = Div(x,y)*y+r & r < y)
  \end

thm Spec_div
  y != 0 -> \e r(x = Div(x,y)*y+r & r < y)

rem 
  \para \bf  Greatest common divisor.  \end Euclid algorithm based on the 
  property 
  \eq* 
    x != 0 & Divides(z,x) -> Divides(z,y) <-> Divides(z,y mod x)
  \end
  \para See also the theorem \it  Euclid_divides_mod  \end in the module \it  
  Maux*  \end. 

fun/2 Gcd1 'Tex_f2_n_gcd'
  Gcd1(0,y) = y
  Gcd1(x,y) = Gcd1(y mod x,x) <- x != 0

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    x != 0 \/ y != 0 -> Divides(Gcd1(x,y),x) & Divides(Gcd1(x,y),y)
  \end
  \eq* 
    (x != 0 \/ y != 0) & Divides(z,x) & Divides(z,y) -> z <= Gcd1(x,y)
  \end
  \para \it  Hint.  \end Use the theorem \it  Mod_bounded  \end in the module 
  \it  Maux*  \end. 

thm Spec_gcd_divides1
  x != 0 \/ y != 0 -> Divides(Gcd1(x,y),x) & Divides(Gcd1(x,y),y)

thm Spec_gcd_greatest1
  (x != 0 \/ y != 0) & Divides(z,x) & Divides(z,y) -> z <= Gcd1(x,y)

rem 
  \para \bf  Subsection. Course of Values Recursion with Measure.  \end 

rem 
  \para \bf  Measure induction.  \end Show that the principle of measure 
  induction (course of values induction with measure) is admissible in Peano 
  arithmetic. 
  \para \it  Remark.  \end Prove the claim for the special case in the following 
  theory. 
  \para \it  Hint.  \end Reduce measure induction to mathematical induction as 
  described in Sect. 8.4 of [1], pg. 243. 

theory Measure_induction

fun M1 'Tex2_g_appl_mu_sb'

pred A 'Tex2_g_appl_phi_sb'

axiom Progressivity
  \a x(\a y(M1(y) < M1(x) -> A(y)) -> A(x))

thm Conclusion
  A(x)

end theory Measure_induction

rem 
  \para \bf  [CL] Measure induction.  \end 
  \header* fun M1 'Tex2_g_appl_mu_sb' \end 
  \header* fun R 'Tex2_g_appl_phi_sb' \end Syntax: 
  \eq* 
    'indm <measure> [; <variable(s)>]'
  \end
  \para where the induction formula is formed from the current sequent. 
  \para Example(s): 
  \items 
   \item \para \ft Tex_f1_g_x_indm M1(x) \end 
         \eq* 
           Tex_f2_g_x_nrule(Tex_f1_g_x_goal R(x),
                            Tex_f1_g_x_goal Tex_f2_g_imp(Tex_f2_g_forall(y,
                                                                         Tex_f2_g_imp(Tex_f2_g_lt(M1(y),
                                                                                                  M1(x)),
                                                                                      R(y))),
                                                         R(x)))
         \end
   \item \para \ft Tex_f1_g_x_indm Tex_f2_g_x_sc(M1(x),a) \end 
         \eq* 
           Tex_f2_g_x_nrule(Tex_f1_g_x_goal R(x),
                            Tex_f1_g_x_goal Tex_f2_g_imp(Tex_f2_g_forall(y,
                                                                         Tex_f2_g_imp(Tex_f2_g_lt(M1(y),
                                                                                                  M1(x)),
                                                                                      Tex_f2_g_forall(a,
                                                                                                      R(y)))),
                                                         R(x)))
         \end
  \end

rem 
  \para \bf  Greatest common divisor.  \end 

rem 
  \para \bf  Greatest common divisor.  \end Euclid algorithm based on the 
  property 
  \eq* 
    x <= y & Divides(z,x) -> Divides(z,y) <-> Divides(z,y-x)
  \end
  \para See also the theorem \it  Euclid_divides_minus  \end in the module \it  
  Maux*  \end. 

fun/2 Gcd2 'Tex_f2_n_gcd'
  Gcd2(x,y) = Max(x,y) <- x = 0
  Gcd2(x,y) = Max(x,y) <- x != 0 & y = 0
  Gcd2(x,y) = Gcd2(x,y-x) <- x != 0 & y != 0 & x < y
  Gcd2(x,y) = x <- x != 0 & y != 0 & x = y
  Gcd2(x,y) = Gcd2(x-y,y) <- x != 0 & y != 0 & x > y

rem 
  \para \bf  [CL] Remark.  \end Note that we have 
  \eq* 
    x = 0 \/ y = 0 -> Gcd2(x,y) = Max(x,y)
  \end

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    x != 0 \/ y != 0 -> Divides(Gcd2(x,y),x) & Divides(Gcd2(x,y),y)
  \end
  \eq* 
    (x != 0 \/ y != 0) & Divides(z,x) & Divides(z,y) -> z <= Gcd2(x,y)
  \end
  \para \it  Hint.  \end Prove the properties by a measure induction. In the 
  induction step, consider two cases according to whether the disjunction 
  \ft x = 0 \/ y = 0 \end holds or not. 

lemma Lemma_spec_gcd_divides2
  (x = 0 \/ y = 0) & (x != 0 \/ y != 0) -> 
  Divides(Gcd2(x,y),x) & Divides(Gcd2(x,y),y)
proof 
 cut x = 0
  weak x = 0; y != 0
   use Divides_right_zero; y
    use Divides_reflexivity; y proved...
  weak x != 0; y = 0
   use Divides_reflexivity; x
    use Divides_right_zero; x proved.....

thm Spec_gcd_divides2
  x != 0 \/ y != 0 -> Divides(Gcd2(x,y),x) & Divides(Gcd2(x,y),y)

lemma Lemma_spec_gcd_greatest2
  (x = 0 \/ y = 0) & (x != 0 \/ y != 0) & Divides(z,x) & Divides(z,y) -> 
  z <= Gcd2(x,y)
proof 
 cut x = 0
  use Divides_bounded; y; z proved.
  use Divides_bounded; x; z proved...

thm Spec_gcd_greatest2
  (x != 0 \/ y != 0) & Divides(z,x) & Divides(z,y) -> z <= Gcd2(x,y)

